## pyferret 7.2

=== Makefile ===
#
# Makefile for building and installing the pyferret module
# and the modules and libraries associated with it.
#

# Site-specific defines
include site_specific.mk

# Platform-specific defines
include platform_specific.mk.$(BUILDTYPE)

.PHONY : all
all : optimized

.PHONY : optimized
optimized :
	mkdir -p $(DIR_PREFIX)/lib
	$(MAKE) -C $(DIR_PREFIX)/fer optimized
	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
	$(MAKE) pymod_optimized_build
	$(MAKE) pymod_optimized_install
	$(MAKE) externals_optimized
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

.PHONY : beta
beta :
	mkdir -p $(DIR_PREFIX)/lib
	$(MAKE) -C $(DIR_PREFIX)/fer beta
	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
	$(MAKE) pymod_optimized_build
	$(MAKE) pymod_optimized_install
	$(MAKE) externals_optimized
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

.PHONY : debug
debug :
	mkdir -p $(DIR_PREFIX)/lib
	$(MAKE) -C $(DIR_PREFIX)/fer debug
	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following defines VERBOSEDEBUG used by fer/grdel, which causes it
## to create a pyferretdebug.log file with all the graphics commands issued
.PHONY : verbosedebug
verbosedebug :
	mkdir -p $(DIR_PREFIX)/lib
	$(MAKE) -C $(DIR_PREFIX)/fer verbosedebug
	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following does an optimized build of libpyferret.so
.PHONY : pymod_optimized_build
pymod_optimized_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export COMPRESS_LIB=$(COMPRESS_LIB) ; \
	  export NETCDF4_LIBDIR=$(NETCDF4_LIBDIR) ; \
	  export IS_LINUX_SYSTEM=$(IS_LINUX_SYSTEM) ; \
	  $(PYTHON_EXE) setup.py --quiet build )

## The following installs libpyferret.so and optimized 
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_optimized_install
pymod_optimized_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export COMPRESS_LIB=$(COMPRESS_LIB) ; \
	  export NETCDF4_LIBDIR=$(NETCDF4_LIBDIR) ; \
	  export IS_LINUX_SYSTEM=$(IS_LINUX_SYSTEM) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_optimized
externals_optimized :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions optimized

## The following does a debug build of libpyferret.so
.PHONY : pymod_debug_build
pymod_debug_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export COMPRESS_LIB=$(COMPRESS_LIB) ; \
	  export NETCDF4_LIBDIR=$(NETCDF4_LIBDIR) ; \
	  export IS_LINUX_SYSTEM=$(IS_LINUX_SYSTEM) ; \
	  $(PYTHON_EXE) setup.py build -g )

## The following installs libpyferret.so and unoptimized
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_debug_install
pymod_debug_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export COMPRESS_LIB=$(COMPRESS_LIB) ; \
	  export NETCDF4_LIBDIR=$(NETCDF4_LIBDIR) ; \
	  export IS_LINUX_SYSTEM=$(IS_LINUX_SYSTEM) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O0 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_debug
externals_debug :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions debug

## Remove everything that was built
.PHONY : clean
clean :
	$(MAKE) -C $(DIR_PREFIX)/bench clean
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix clean
	$(MAKE) -C $(DIR_PREFIX)/external_functions clean
	rm -fr $(DIR_PREFIX)/install $(DIR_PREFIX)/build ferret.jnl*
	find $(DIR_PREFIX)/pviewmod -name '*.py[co]' -delete
	find $(DIR_PREFIX)/pyfermod -name '*.py[co]' -delete
	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser clean
	$(MAKE) -C $(DIR_PREFIX)/fer clean
	rm -fr $(DIR_PREFIX)/lib

## Install Ferret binaries, scripts, and other files into $(INSTALL_FER_DIR)
.PHONY : install
install :
	rm -f pyferret-latest-local.tar.gz
	bin/make_dist_tar . latest local . -y
	mkdir -p $(INSTALL_FER_DIR)
	mv -f pyferret-latest-local.tar.gz $(INSTALL_FER_DIR)
	( cd $(INSTALL_FER_DIR) ; tar xz --strip-components=1 -f pyferret-latest-local.tar.gz )

## The following is for installing the updated threddsBrowser.jar, ferret_ef_meme_subsc.so,
## libpyferret.so, and PyFerret python scripts into $(INSTALL_FER_DIR)/lib without having 
## to use the distribution tar file.  Also copies all the PyFerret Fortran external function 
## to the $(INSTALL_FER_DIR)/ext_func/pylibs directory.
.PHONY : update
update :
	mkdir -p $(INSTALL_FER_DIR)/lib
	cp -f $(DIR_PREFIX)/threddsBrowser/threddsBrowser.jar $(INSTALL_FER_DIR)/lib
	find $(DIR_PREFIX)/external_functions -type f -perm -100 -name \*.so -exec cp {} $(INSTALL_FER_DIR)/ext_func/pylibs \;
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export COMPRESS_LIB=$(COMPRESS_LIB) ; \
	  export NETCDF4_LIBDIR=$(NETCDF4_LIBDIR) ; \
	  export IS_LINUX_SYSTEM=$(IS_LINUX_SYSTEM) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(INSTALL_FER_DIR) )

## Execute the RUN_TESTS.sh tests
.PHONY : run_tests
run_tests :
	$(MAKE) -C $(DIR_PREFIX)/bench run_tests

##

=== bench/Makefile ===
#
# Makefile for the PyFerret bench subdirectory
#

# include platform specific macro definitions for make_stream_file
include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

## Execute the RUN_TESTS.sh test suite
.PHONY: run_tests
run_tests:
	@if [ `which pyferret` = "" -o "$(FER_DIR)" = "" ]; then \
	    echo "*** PyFerret must be installed and the ferret_paths script must have sourced for these tests ***" ; \
	    exit 1 ; \
	fi
	./RUN_TESTS.sh `which pyferret` "$(PYFER_EXTERNAL_FUNCTIONS)"
	@echo 'Differences in the generated bench PDF and PNG files versus those in bench/test_results'
	-@for img in *.pdf *.png ; \
	do \
	    if diff -q $$img test_results/$$img ; then \
	        echo "Files $$img and test_results/$$img are identical"; \
	    else \
	        compare $$img test_results/$$img "$$img"_diff.png ; \
	    fi \
	done
	-@( datetag=`date +'%d%h%yAT'|tr '[A-Z]' '[a-z]'` ; \
	    diff all_$${datetag}*_ncdump test_results/pyferret_run_tests_ncdump 1> pyferret_run_tests_ncdump.diff 2>&1 ; \
	    diff all_$${datetag}*_err test_results/pyferret_run_tests_err 1> pyferret_run_tests_err.diff 2>&1 ; \
	    diff all_$${datetag}*_log test_results/pyferret_run_tests_log 1> pyferret_run_tests_log.diff 2>&1 \
	)
	@echo ''
	@echo 'Inspect the *_diff.png files for actual differences in the images'
	@echo 'Inspect the pyferret_run_tests_*.diff files for actual differences in the output'

.PHONY: clean
clean:
	rm -f all_*_ncdump all_*_err all_*_log all_*_ncdump_orig all_*_err_orig all_*_log_orig cleanups.sed
	rm -f *.ps* *.eps* *.png* *.pdf* *.diff* ferret.jnl*
	rm -f `cat TRASH_FILES`
	rm -f all_ncdump.out fort.41 make_stream_file
	rm -fr subdir tmp

make_stream_file: make_stream_file.F
	$(FC) $(FFLAGS) make_stream_file.F -o make_stream_file

#
# End of Makefile
#

=== fer/Makefile ===
#
# Simple makefile for launching other makes to build all the ferret libraries
#

#
# Site-specific defines
#
include ../site_specific.mk

#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#
include ../platform_specific.mk.$(BUILDTYPE)

PLATFORM := $(shell uname -rs)
DATE := $(shell /bin/date +%D)

#
# Macros
#

DIRS = ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
       ino mem plt pyf rpn stk utl xeq special

LIBS = ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
       ino mem plt pyf rpn stk utl xeq 

#
# Targets
#

.PHONY : all
all: optimized


.PHONY : optimized
optimized:
	$(MAKE) "CFLAGS = $(CFLAGS) $(OPT_FLAGS)" \
		"FFLAGS = $(FFLAGS) $(OPT_FLAGS)" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PPLUS_OPT_FLAGS)" \
		"VERSION_INFO = (optimized)" \
		build

.PHONY : beta
beta:
	$(MAKE) "CFLAGS = $(CFLAGS) $(OPT_FLAGS)" \
		"FFLAGS = $(FFLAGS) $(OPT_FLAGS)" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PPLUS_OPT_FLAGS)" \
		"VERSION_INFO = (beta/optim)" \
		build

.PHONY : debug
debug:
	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS)"  \
		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
		"VERSION_INFO = (beta/debug)" \
		build

## The definition of VERBOSEDEBUG is observed by fer/grdel, which causes it
## to create a pyferretdebug.log file with all the graphics commands issued
.PHONY : verbosedebug
verbosedebug:
	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS) -DVERBOSEDEBUG"  \
		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
		"VERSION_INFO = (beta/debug)" \
		build

.PHONY: profiling
profiling:
	$(MAKE) "CFLAGS = $(CFLAGS) $(PROF_FLAGS) "  \
		"FFLAGS = $(FFLAGS) $(PROF_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PROF_FLAGS)" \
		"LDFLAGS = $(LDFLAGS) $(PROF_FLAGS)" \
		"VERSION_INFO = (profiling)" \
		build

.PHONY : build
build: update special_code ppl_libraries fmt_libraries fer_libraries


.PHONY : update
update:
	rm -f special/xmake_date_data.[Ffo]
	sed "s&xxxxxxxx&$(DATE)&" < special/xmake_date_data.template > special/xmake_date_data.F
	rm -f special/xrevision_type_data.[Ffo]
	sed -e 's&mmmmmmmm&$(VERSION_INFO)&' -e 's&(/&(&' -e 's&/)&)&' < special/xrevision_type_data.template > special/xrevision_type_data.F 
	rm -f special/xplatform_type_data.[Ffo]
	sed -e 's&mmmmmmmm&$(PLATFORM)&' -e 's&(/&(&' -e 's&/)&)&' < special/xplatform_type_data.template > special/xplatform_type_data.F 


.PHONY : special_code
special_code: update
	$(MAKE) -C special all


.PHONY : ppl_libraries
ppl_libraries:
	$(MAKE) -C ../ppl


.PHONY : fmt_libraries
fmt_libraries:
	$(MAKE) -C ../fmt/src


.PHONY : fer_libraries
fer_libraries: update
	for i in $(LIBS) ; do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done


.PHONY : clean
clean: ppl_clean fmt_clean fer_clean
	rm -f ../lib/*


.PHONY : ppl_clean
ppl_clean:
	$(MAKE) -C ../ppl clean


.PHONY : fmt_clean
fmt_clean:
	$(MAKE) -C ../fmt/src clean


.PHONY : fer_clean
fer_clean:
	for i in $(DIRS) ; do \
            $(MAKE) -C $$i clean ; \
        done
	rm -f special/xmake_date_data.F special/xrevision_type_data.F special/xplatform_type_data.F

#
# End of Makefile
#

=== debian/changelog ===
pyferret (7.2-1build1) artful; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Aug 2017 19:13:49 +0000

pyferret (7.2-1) unstable; urgency=medium

  * Mew upstream release
  * Patch from Simon Quigleyo ensure we are py3-version neutral.
    Closes: #869235
  * Add gbp.conf file
  * __init__.py: Add default values for FER_PALETTE, etc.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 22 Jul 2017 16:43:34 +0100

pyferret (7.1.1.beta-1) unstable; urgency=medium

  * New upstream release.
    - remove obsolete py3 patches
    - patch to fixup setup.py for py3 libname
  * Ignore tests for this build 
  * Standards-Version: 4.0.0. No changes required
  * Enable builds with python3.5, py3.6 simultaneously. Closes: #863004

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 25 Jun 2017 11:05:57 +0100

pyferret (7.0.0-3) unstable; urgency=medium

  * Move to DH_COMPAT=10
  * Depend on python*-dev not python*-all-dev. Closes: #863994

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 May 2017 07:06:22 +0100

=== debian/control ===
Source: pyferret
Standards-Version: 4.0.0
Homepage: http://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
Vcs-Git: git://git.debian.org/git/debian-science/packages/pyferret.git
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.2
Build-Depends: debhelper (>= 10), gfortran, csh, dh-python,
 libreadline-dev, libcurl4-openssl-dev | libcurl-dev, libncurses-dev, 
 libnetcdf-dev (>= 4.3.0), libnetcdff-dev,
 libxpm-dev, libxt-dev, libcairo2-dev, libpango1.0-dev,
 python-dev, python3-dev,
 python-numpy, python3-numpy,
 python-future, python3-future,
 java-common, default-jdk-headless, 
 ferret-vis

Package: python-ferret
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python:Depends}, python-future
Recommends: ferret-datasets
Description: Python wrapper for the Ferret visualization and analysis environment
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 This is the Python wrapper for Ferret

Package: python3-ferret
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python3:Depends}, python3-future
Recommends: ferret-datasets
Description: Python3 wrapper for the Ferret visualization and analysis environment,
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 This is the Python3 wrapper for Ferret

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# magic debhelper rule
%:
	dh $@ --with python2,python3

# To aid reproducible builds
LC_ALL=C
export LC_ALL

ARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(ARCH)
INSTALLDIR:=$(CURDIR)/debian/tmp

PY2:=$(shell pyversions -d)
PY3:=$(shell py3versions -d)
PY3nodot:=$(shell py3versions -dv | tr -d '.')

override_dh_auto_build:
	cp debian/platform_specific.mk.debian .
	cp debian/ef_utility/platform_specific.mk.debian external_functions/ef_utility/platform_specific.mk.debian
	sed -e 's%@ARCH@%${ARCH}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e 's%@INSTALLDIR@%${INSTALLDIR}%' \
                < debian/site_specific.mk.in > site_specific.mk
	cp site_specific.mk external_functions/ef_utility

override_dh_auto_install:
	# Need temp. libraries during build.
	mkdir -p $(INSTALLDIR)/lib/$(PY2)
	mkdir -p $(INSTALLDIR)/lib/$(PY3)
	ln -s $(CURDIR)/install/lib/$(PY2)/site-packages/pyferret/libpyferret.so \
		$(INSTALLDIR)/lib/$(PY2)/libpyferret.so
	ln -s $(CURDIR)/install/lib/$(PY3)/site-packages//pyferret/libpyferret.cpython-$(PY3nodot)m-$(ARCH).so \
		$(INSTALLDIR)/lib/$(PY3)/libpyferret.so
	# Build and install 
	# Horrible hack breaks The Debian Way. I'm doing the build in the 'install' phase, as i'm installing into debian/tmp
	# Doing it any earlier, and dh_prep will remove debian/tmp. 
	# This means I'm also doing 'test' after the Install, not between during make & install. gack.
	for p in $(PY2) $(PY3) ; do \
		$(MAKE) HOSTTYPE=debian PYTHON_EXE=$$p clean all install ; \
		done
	find debian -name '*.pyo' -o -name '*.pyc' -delete
	find debian -type d -name __pycache__ -delete
	dh_numpy
	dh_numpy3
	@echo "Now doing bench tests"
	ln -s debian/pyferret2  $(INSTALLDIR)/lib/$(PY2)/pyferret
	ln -s debian/pyferret3  $(INSTALLDIR)/lib/$(PY3)/pyferret
	# First build necessary files
	for p in $(PY2) $(PY3) ; do \
		sed -e 's%@ARCH@%${ARCH}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e "s%@PYTHON@%$$p%" \
                < debian/site_specific.mk.in > site_specific.mk ; \
		PATH=$(INSTALLDIR)/lib/$$p:$(PATH) PYTHONPATH=$(INSTALLDIR)/lib/$$p/site-packages \
		echo "IGNORING TESTS" ;  \
		done

override_dh_auto_test:
	@echo "Dummy test, to avoid calling make. Do test later"

override_dh_auto_clean:
	# use system xpm.h, not supplied ones
	rm -f fer/gui/xpm*.h
	rm -rf ./build ./install
	find . -type l  -delete 
	find . -name '*.o' -o -name '*.so'  -delete
	[ ! -f platform_specific_flags.mk.debian ]  || $(MAKE)  clean HOSTTYPE=debian

## pyferret 7.3

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,6 @@
 optimized :
 	mkdir -p $(DIR_PREFIX)/lib
 	$(MAKE) -C $(DIR_PREFIX)/fer optimized
-	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
 	$(MAKE) pymod_optimized_build
 	$(MAKE) pymod_optimized_install
 	$(MAKE) externals_optimized
@@ -26,7 +25,6 @@
 beta :
 	mkdir -p $(DIR_PREFIX)/lib
 	$(MAKE) -C $(DIR_PREFIX)/fer beta
-	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
 	$(MAKE) pymod_optimized_build
 	$(MAKE) pymod_optimized_install
 	$(MAKE) externals_optimized
@@ -36,19 +34,31 @@
 debug :
 	mkdir -p $(DIR_PREFIX)/lib
 	$(MAKE) -C $(DIR_PREFIX)/fer debug
-	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
 	$(MAKE) pymod_debug_build
 	$(MAKE) pymod_debug_install
 	$(MAKE) externals_debug
 	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix
 
-## The following defines VERBOSEDEBUG used by fer/grdel, which causes it
-## to create a pyferretdebug.log file with all the graphics commands issued
-.PHONY : verbosedebug
-verbosedebug :
+## The definition of MEMORYDEBUG is observed by fer/special/FerMem_routines.c, 
+## which causes it to print (append) all memory allocations, reallocations, 
+## and frees to file "memorydebug.txt".  Initialize allocated memory with 
+## non-zero values.  Expect this to be a lot slower due to all the 
+## (intentionally inefficient but safe) file operations.
+.PHONY : memorydebug
+memorydebug :
 	mkdir -p $(DIR_PREFIX)/lib
-	$(MAKE) -C $(DIR_PREFIX)/fer verbosedebug
-	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser
+	$(MAKE) -C $(DIR_PREFIX)/fer memorydebug
+	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_build
+	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_install
+	$(MAKE) externals_debug
+	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix
+
+## The following defines GRDELDEBUG used by fer/grdel, which causes it
+## to create a grdeldebug.log file with all the graphics commands issued
+.PHONY : grdeldebug
+grdeldebug :
+	mkdir -p $(DIR_PREFIX)/lib
+	$(MAKE) -C $(DIR_PREFIX)/fer grdeldebug
 	$(MAKE) pymod_debug_build
 	$(MAKE) pymod_debug_install
 	$(MAKE) externals_debug
@@ -141,7 +151,6 @@
 	rm -fr $(DIR_PREFIX)/install $(DIR_PREFIX)/build ferret.jnl*
 	find $(DIR_PREFIX)/pviewmod -name '*.py[co]' -delete
 	find $(DIR_PREFIX)/pyfermod -name '*.py[co]' -delete
-	$(MAKE) -C $(DIR_PREFIX)/threddsBrowser clean
 	$(MAKE) -C $(DIR_PREFIX)/fer clean
 	rm -fr $(DIR_PREFIX)/lib
 
@@ -154,14 +163,13 @@
 	mv -f pyferret-latest-local.tar.gz $(INSTALL_FER_DIR)
 	( cd $(INSTALL_FER_DIR) ; tar xz --strip-components=1 -f pyferret-latest-local.tar.gz )
 
-## The following is for installing the updated threddsBrowser.jar, ferret_ef_meme_subsc.so,
-## libpyferret.so, and PyFerret python scripts into $(INSTALL_FER_DIR)/lib without having 
-## to use the distribution tar file.  Also copies all the PyFerret Fortran external function 
-## to the $(INSTALL_FER_DIR)/ext_func/pylibs directory.
+## The following is for installing the updated ferret_ef_meme_subsc.so, libpyferret.so, 
+## and PyFerret python scripts into $(INSTALL_FER_DIR)/lib without having to use the 
+## distribution tar file.  Also copies all the PyFerret Fortran external function to 
+## the $(INSTALL_FER_DIR)/ext_func/pylibs directory.
 .PHONY : update
 update :
 	mkdir -p $(INSTALL_FER_DIR)/lib
-	cp -f $(DIR_PREFIX)/threddsBrowser/threddsBrowser.jar $(INSTALL_FER_DIR)/lib
 	find $(DIR_PREFIX)/external_functions -type f -perm -100 -name \*.so -exec cp {} $(INSTALL_FER_DIR)/ext_func/pylibs \;
 	( cd $(DIR_PREFIX) ; \
 	  export CC=$(CC) ; \
@@ -176,9 +184,9 @@
 	  export IS_LINUX_SYSTEM=$(IS_LINUX_SYSTEM) ; \
 	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(INSTALL_FER_DIR) )
 
-## Execute the RUN_TESTS.sh tests
-.PHONY : run_tests
-run_tests :
-	$(MAKE) -C $(DIR_PREFIX)/bench run_tests
+## Execute the benchmark tests
+.PHONY : check
+check : 
+	$(MAKE) -C $(DIR_PREFIX)/bench check
 
 ##

=== bench/Makefile ===
--- 
+++ 
@@ -6,6 +6,10 @@
 include ../site_specific.mk
 include ../platform_specific.mk.$(BUILDTYPE)
 
+## For PyFerret, use run_tests as the standard check
+.PHONY: check
+check: run_tests
+
 ## Execute the RUN_TESTS.sh test suite
 .PHONY: run_tests
 run_tests:
@@ -13,7 +17,7 @@
 	    echo "*** PyFerret must be installed and the ferret_paths script must have sourced for these tests ***" ; \
 	    exit 1 ; \
 	fi
-	./RUN_TESTS.sh `which pyferret` "$(PYFER_EXTERNAL_FUNCTIONS)"
+	( SED_EXTREGEX_FLAG="$(SED_EXTREGEX_FLAG)"; export SED_EXTREGEX_FLAG; ./RUN_TESTS.sh `which pyferret` "$(PYFER_EXTERNAL_FUNCTIONS)" )
 	@echo 'Differences in the generated bench PDF and PNG files versus those in bench/test_results'
 	-@for img in *.pdf *.png ; \
 	do \

=== external_functions/cat/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	list_good.so xcat.so ycat.so zcat.so tcat.so xreverse.so yreverse.so zreverse.so treverse.so
all:	list_good.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/closest_in_list/Makefile ===
#
# Makefile for Ferret External Functions
#
# *sh* 2/26/00
#

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	closest_in_zlist.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/cmprsi_by/Makefile ===
#
# Makefile for Ferret External Functions
#
# *sh* 12/27/00
# *sh* 1/02 -- updated to add expndi_by
# *sh* 2/02 -- updated to add expndi_by_z
# *acm*2/02 -- cmprsi_by has been replaced by family of compress_by
#              functions, which are internally linked.
# acm* 4/13 -- new expndi_by_m_counts
#

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	expndi_by.so expndi_by_z.so expndi_by_t.so cmprsi_by.so expndi_by_z_counts.so 
all:	expndi_by_m_counts.so 

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/contributed/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
# *sh* 2/2000 - removed SAMPLEIJ from target list (replaced by SAMPLEXY)
#
# *acm* 1/2001 - incorporate "make debug" as per SH Makefiles
#  acm  2/2001   debug macros
#  acm  5/2007   removed fill_xy from target list; now statically-linked.

#
# include site-specific definitions
#
include ../ef_utility/site_specific.mk

#
# include platform-specific definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/convolve/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
# *acm* 1/2001 - add "make debug" target as per SH Makefiles
#  ACM  2/2001    use debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	convolvei.so convolvej.so convolvek.so convolvel.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/decimate/Makefile ===
#
# Makefile for Ferret External Functions
#
#
# include platform specific macro definitions
#
include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)
 
#
# Macros
#

.SUFFIXES: .so
SUB_OBJS = piecewise_subs.o

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

#all:	$(SUB_OBJS) piecewise.so piecewise3.so piecewise1.so piecewise2.so separate.so sample_fast_i.so sample_rows.so apply_qc.so sample_fast_i_str.so sample_rows.so
all:	$(SUB_OBJS) piecewise3.so separate.so separate_str.so sample_fast_i.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/ef_utility/Makefile ===
#
# Site-specific defines
#
include site_specific.mk

#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#
include platform_specific.mk.$(BUILDTYPE)

#
# The COPY_FERRET_EF_MEM_SUBSC subroutine needs to be called at the start 
# of the compute method of any PyFerret external function written in Fortran 
# in order to make an external copy of the (Py)Ferret internal common block 
# FERRET_EF_MEM_SUBSC.  Because the PyFerret module is shared-object library 
# loaded privately by Python, the Ferret common blocks are not visible to 
# these external functions. 
#

#
# Targets
#

.PHONY: all
all: copy_ferret_ef_mem_subsc.o

.PHONY: install
install:

.PHONY: clean
clean:
	rm -f *.o

#
# End of Makefile
#

=== external_functions/eof/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM  2/2001  debug macros
#  ACM  Jul 2001 Move to statically linked code in fer/efi.  name functions
#                eofspace, eofstat, eoftfunc; with same code as in fer/efi,
#                but with different INCLUDE statements for use in testing
#                as dynamically-linked functions.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

SUB_OBJS = eofsubs.o

#
# Rules
#

#   once eof_space etc are linked into Ferret dont need SUB_OBJS

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	eofsubs.o eof_space_tgap.so eof_tfunc_tgap.so eof_stat_tgap.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

# To make a tarfile with the older functions that work on gappy timeseries:
# make; make tarfile
tarfile:
	rm -f fer_eof_gappy_timeseries_fcns.tar*
	tar cf fer_eof_gappy_timeseries_fcns.tar *.so
	gzip -9 fer_eof_gappy_timeseries_fcns.tar

#
# End of Makefile
#

=== external_functions/examples/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk
 
#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	add_9.so appende.so avet.so dates.so factorial.so pass_thru.so percent_good_t.so \
	storage.so string_arg.so subtract.so earth_distance.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/featurecollections/Makefile ===
#
# Makefile for Ferret External Functions
#
# include platform specific macro definitions
#
include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)
 
#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	fc_isubset.so expnd_by_len.so
 
debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== debian/changelog ===
pyferret (7.3-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.2; no changes required
  * Fix find in clean target to delete properly. Closes: #876723
  * Add recommends for scipy, pyshp

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 09 Dec 2017 12:40:50 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: pyferret
-Standards-Version: 4.0.0
+Standards-Version: 4.1.2
 Homepage: http://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
 Vcs-Git: git://git.debian.org/git/debian-science/packages/pyferret.git
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
@@ -8,9 +8,14 @@
 X-Python-Version: >= 2.6
 X-Python3-Version: >= 3.2
 Build-Depends: debhelper (>= 10), gfortran, csh, dh-python,
- libreadline-dev, libcurl4-openssl-dev | libcurl-dev, libncurses-dev, 
+ libreadline-dev, 
+ libcurl4-openssl-dev | libcurl-dev, 
+ libncurses-dev, 
  libnetcdf-dev (>= 4.3.0), libnetcdff-dev,
- libxpm-dev, libxt-dev, libcairo2-dev, libpango1.0-dev,
+ libxpm-dev, 
+ libxt-dev, 
+ libcairo2-dev, 
+ libpango1.0-dev,
  python-dev, python3-dev,
  python-numpy, python3-numpy,
  python-future, python3-future,
@@ -21,7 +26,7 @@
 Architecture: any
 Section: python
 Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python:Depends}, python-future
-Recommends: ferret-datasets
+Recommends: ferret-datasets, python-scipy, python-pyshp
 Description: Python wrapper for the Ferret visualization and analysis environment
  Ferret is an interactive computer visualization and analysis environment
  designed to meet the needs of oceanographers and meteorologists analyzing
@@ -34,7 +39,7 @@
 Architecture: any
 Section: python
 Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python3:Depends}, python3-future
-Recommends: ferret-datasets
+Recommends: ferret-datasets, python3-scipy, python3-pyshp
 Description: Python3 wrapper for the Ferret visualization and analysis environment,
  Ferret is an interactive computer visualization and analysis environment
  designed to meet the needs of oceanographers and meteorologists analyzing

=== debian/rules ===
--- 
+++ 
@@ -44,7 +44,7 @@
 	for p in $(PY2) $(PY3) ; do \
 		$(MAKE) HOSTTYPE=debian PYTHON_EXE=$$p clean all install ; \
 		done
-	find debian -name '*.pyo' -o -name '*.pyc' -delete
+	find debian \( -name '*.pyo' -o -name '*.pyc' \) -delete
 	find debian -type d -name __pycache__ -delete
 	dh_numpy
 	dh_numpy3

## pyferret 7.4

=== Makefile ===
#
# Makefile for building and installing the pyferret module
# and the modules and libraries associated with it.
#

# Site-specific defines
include site_specific.mk

# Platform-specific defines
include platform_specific.mk.$(BUILDTYPE)

ifeq ("$(BUILDTYPE)", "intel-mac")
	COPY_DYLIBS = - ( cd $(DIR_PREFIX); ./copy_dylibs.sh )
else
	COPY_DYLIBS =
endif

.PHONY : all
all : optimized

.PHONY : optimized
optimized :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer optimized
	$(MAKE) pymod_optimized_build
	$(MAKE) pymod_optimized_install
	$(MAKE) externals_optimized
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

.PHONY : beta
beta :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer beta
	$(MAKE) pymod_optimized_build
	$(MAKE) pymod_optimized_install
	$(MAKE) externals_optimized
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

.PHONY : debug
debug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer debug
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The definition of MEMORYDEBUG is observed by fer/special/FerMem_routines.c,
## which causes it to print (append) all memory allocations, reallocations,
## and frees to file "memorydebug.txt".  Initialize allocated memory with
## non-zero values.  Expect this to be a lot slower due to all the
## (intentionally inefficient but safe) file operations.
.PHONY : memorydebug
memorydebug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer memorydebug
	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_build
	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following defines GRDELDEBUG used by fer/grdel, which causes it
## to create a grdeldebug.log file with all the graphics commands issued
.PHONY : grdeldebug
grdeldebug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer grdeldebug
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following does an optimized build of libpyferret.so
.PHONY : pymod_optimized_build
pymod_optimized_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet build )

## The following installs libpyferret.so and optimized
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_optimized_install
pymod_optimized_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_optimized
externals_optimized :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions optimized

## The following does a debug build of libpyferret.so
.PHONY : pymod_debug_build
pymod_debug_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py build -g )

## The following installs libpyferret.so and unoptimized
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_debug_install
pymod_debug_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O0 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_debug
externals_debug :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions debug

## Remove everything that was built
.PHONY : clean
clean :
	$(MAKE) -C $(DIR_PREFIX)/bench clean
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix clean
	$(MAKE) -C $(DIR_PREFIX)/external_functions clean
	rm -fr $(DIR_PREFIX)/install $(DIR_PREFIX)/build ferret.jnl*
	find $(DIR_PREFIX)/pviewmod -name '*.py[co]' -delete
	find $(DIR_PREFIX)/pyfermod -name '*.py[co]' -delete
	$(MAKE) -C $(DIR_PREFIX)/fer clean
	rm -fr $(DIR_PREFIX)/lib $(DIR_PREFIX)/dylibs

## Install Ferret binaries, scripts, and other files into $(INSTALL_FER_DIR)
.PHONY : install
install :
	rm -f pyferret-latest-local.tar.gz
	bin/make_dist_tar . latest local . -y
	mkdir -p $(INSTALL_FER_DIR)
	mv -f pyferret-latest-local.tar.gz $(INSTALL_FER_DIR)
	( cd $(INSTALL_FER_DIR) ; tar xz --strip-components=1 -f pyferret-latest-local.tar.gz )

## The following is for installing the updated ferret_ef_meme_subsc.so, libpyferret.so,
## and PyFerret python scripts into $(INSTALL_FER_DIR)/lib without having to use the
## distribution tar file.  Also copies all the PyFerret Fortran external function to
## the $(INSTALL_FER_DIR)/ext_func/pylibs directory.
.PHONY : update
update :
	mkdir -p $(INSTALL_FER_DIR)/lib
	find $(DIR_PREFIX)/external_functions -type f -perm -100 -name \*.so -exec cp {} $(INSTALL_FER_DIR)/ext_func/pylibs \;
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(INSTALL_FER_DIR) )

## Execute the benchmark tests
.PHONY : check
check :
	$(MAKE) -C $(DIR_PREFIX)/bench check

##

=== debian/changelog ===
pyferret (7.4-1build1) cosmic; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:44:27 +0000

pyferret (7.4-1) unstable; urgency=medium

  * New upstream release
  * Drop Java dependencies; threddsBrowser code no longer shipped
  * Standards-Version: 4.1.4
  * Set NETCDF_LIB in site_specific.mk.in 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 Apr 2018 15:32:40 +0100

pyferret (7.3-2) unstable; urgency=medium

  * Standards-Version: 4.1.3
  * Point VCS to salsa.debian.org

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 Mar 2018 13:13:14 +0000

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,33 @@
 Source: pyferret
-Standards-Version: 4.1.2
+Standards-Version: 4.1.4
 Homepage: http://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
-Vcs-Git: git://git.debian.org/git/debian-science/packages/pyferret.git
+Vcs-Browser: https://salsa.debian.org:/science-team/pyferret
+Vcs-Git: https://salsa.debian.org:/science-team/pyferret.git
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Section: science
 Priority: optional
 X-Python-Version: >= 2.6
 X-Python3-Version: >= 3.2
-Build-Depends: debhelper (>= 10), gfortran, csh, dh-python,
+Build-Depends: debhelper (>= 10),
+ gfortran,
+ pkg-config,
+ csh,
+ dh-python,
  libreadline-dev, 
  libcurl4-openssl-dev | libcurl-dev, 
  libncurses-dev, 
- libnetcdf-dev (>= 4.3.0), libnetcdff-dev,
+ libnetcdf-dev (>= 4.3.0),
+ libnetcdff-dev,
  libxpm-dev, 
  libxt-dev, 
  libcairo2-dev, 
  libpango1.0-dev,
- python-dev, python3-dev,
- python-numpy, python3-numpy,
- python-future, python3-future,
- java-common, default-jdk-headless, 
+ python-dev,
+ python3-dev,
+ python-numpy,
+ python3-numpy,
+ python-future,
+ python3-future,
  ferret-vis
 
 Package: python-ferret
